/*##############################################################################

Copyright (C) 2007 Ulrich Radig

##############################################################################*/

#ifndef _UART_H
#define _UART_H

//##############################################################################

#include <avr/interrupt.h>
#include <avr/io.h>
#include <stdio.h>
#include <string.h>	
#include "support.h"

//##############################################################################

#define LF 10
#define CR 13
#define ESC 27
#define SPC 32

//##############################################################################

//Der Quarz auf dem Experimentierboard hat eine Frequenz von 14.318MHz
//#define SYSCLK	14318180	//Quarz Frequenz in Hz
#define SYSCLK	8000000	//Quarz Frequenz in Hz

#define BUFFER_SIZE 100

//Die Baud_Rate der Seriellen Schnittstelle ist 9600 Baud
//#define BAUD_RATE 4800		//Baud Rate fr die Serielle Schnittstelle	
#define BAUD_RATE 9600		//Baud Rate fr die Serielle Schnittstelle	
//#define BAUD_RATE 14400		//Baud Rate fr die Serielle Schnittstelle	
//#define BAUD_RATE 28800		//Baud Rate fr die Serielle Schnittstelle	
//#define BAUD_RATE 38400		//Baud Rate fr die Serielle Schnittstelle	
//#define BAUD_RATE 57600		//Baud Rate fr die Serielle Schnittstelle	

//Anpassen der seriellen Schnittstellen Register wenn ein ATMega128 benutzt wird
#if defined (__AVR_ATmega128__)
#	define RX_INTERRUPT SIG_USART_RECV
#	define USR UCSR0A
#	define UCR UCSR0B
#	define UDR UDR0
#	define UBRR UBRR0L
#	define EICR EICRB
#endif

#if defined (__AVR_ATmega32__)
#	define RX_INTERRUPT SIG_USART_RECV
#	define USR UCSRA
#	define UCR UCSRB
#	define UBRR UBRRL
#	define EICR EICRB
#endif

#if defined (__AVR_ATmega8__)
#	define RX_INTERRUPT SIG_UART_RECV 
#	define USR UCSRA
#	define UCR UCSRB
#	define UBRR UBRRL
#endif

#if defined (__AVR_ATmega88__)
#	define RX_INTERRUPT SIG_USART_RECV 
#	define USR UCSR0A
#	define UCR UCSR0B
#	define UBRR UBRR0L
#	define TXEN TXEN0
#	define RXEN RXEN0
#	define UDR UDR0
#	define UDRE UDRE0
#	define RXCIE RXCIE0
#endif
//##############################################################################
extern volatile BOOL usart_ready;
extern volatile U08 usart_buffer[];
extern volatile U08 usart_get[];

void usart_init(void); 
int usart_write_char(char c);
void usart_write_str(char *str);
void usart_writeln_flash_str(const char *str);
void usart_writeln_str(char *data);
void usart_write_U08(char data);
void usart_write_U16(int data);
void usart_write_U08_hex(char data);
//SIGNAL (SIG_UART0_RECV);

//##############################################################################

#endif //_UART_H

